=== dolfin/math/CMakeLists.txt ===
set(HEADERS
  basic.h
  dolfin_math.h
  Lagrange.h
  Legendre.h
  PARENT_SCOPE)

set(SOURCES
  basic.cpp
  Lagrange.cpp
  Legendre.cpp
  PARENT_SCOPE)
