=== dolfin/nls/CMakeLists.txt ===
set(HEADERS
  dolfin_nls.h
  NewtonSolver.h
  NonlinearProblem.h
  OptimisationProblem.h
  PETScSNESSolver.h
  PETScTAOSolver.h
  TAOLinearBoundSolver.h
  PARENT_SCOPE)

set(SOURCES
  NewtonSolver.cpp
  PETScSNESSolver.cpp
  PETScTAOSolver.cpp
  TAOLinearBoundSolver.cpp
  PARENT_SCOPE)
