=== debian/changelog ===
dolfin (2019.1.0-4) unstable; urgency=medium

  * Standards-Version: 4.4.0
  * drop python-dolfin
  * skip the demo_bcs_mpi test on ia64

 -- Drew Parsons <dparsons@debian.org>  Mon, 05 Aug 2019 09:41:17 +0800

dolfin (2019.1.0-3) experimental; urgency=medium

  * autopkgtest: report CPUs available (merge 2018.1.0.post1-18)

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Jun 2019 12:38:07 +0800

dolfin (2019.1.0-2) experimental; urgency=medium

  * debian/README.source: document the file format of
    scripts/dolfin-convert/test_exodus.exo as Exodus II
    (can view in paraview)
  * update debian/copyright (AUTHORS, io/pugi*)
  * merge C++ unit tests into debian/tests from 2018.1.0.post1-17

 -- Drew Parsons <dparsons@debian.org>  Sat, 01 Jun 2019 12:04:49 +0800

dolfin (2019.1.0-1) experimental; urgency=medium

  * New upstream release (official).
    - applies patches:
      * PETSc_3.10_SNESTEST_removed.patch
      * conditional-parmetis-in-cholmod.patch
      * test_mpi_oversubscribe.patch
      * unittests_demos_include_dirs.patch
      * v2019.1.patch
  * debhelper 12: Build-Depends: debhelper-compat (= 12)
  * apply debian patch revert_PETSc3.11_8e92f6ee.patch:
    VecScatterCreateWithData never made it into PETSc 3.11

 -- Drew Parsons <dparsons@debian.org>  Thu, 25 Apr 2019 22:43:54 +0800

dolfin (2019.1.0~git20190216+lfs-1) experimental; urgency=medium

  * New upstream test release.
    - applies pytest_fixtures_096217a.patch
    - demo data files pulled in from git lfs
  * debian patch v2019.1.patch bumps DOLFIN_VERSION to 2019.1
    (needed to set soname for libdolfin.so)

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Mar 2019 10:40:45 +0800

dolfin (2018.1.0.post1-18) unstable; urgency=medium

  * debian/tests (autopkgtest): report CPUs available and used for
    C++ MPI demos (tracking flaky timeouts, Bug#920546)

 -- Drew Parsons <dparsons@debian.org>  Sat, 01 Jun 2019 13:30:35 +0800

dolfin (2018.1.0.post1-17) unstable; urgency=medium

  * debian/tests (autopkgtest): run C++ unit tests

 -- Drew Parsons <dparsons@debian.org>  Fri, 31 May 2019 23:24:20 +0800
